Index: cpu/ppc4xx/speed.c
===================================================================
RCS file: /srv/CVS/pplinux/u-boot/cpu/ppc4xx/speed.c,v
retrieving revision 1.1.333.1
retrieving revision 1.2
diff -u -r1.1.333.1 -r1.2
--- cpu/ppc4xx/speed.c	3 Feb 2005 09:43:12 -0000	1.1.333.1
+++ cpu/ppc4xx/speed.c	29 Apr 2005 08:43:29 -0000	1.2
@@ -189,6 +189,21 @@
 	return val;
 }
 
+/********************************************
+ * get_EPB_freq
+ * return EPB bus freq in Hz
+ *********************************************/
+ulong get_EPB_freq (void)
+{
+	ulong val = 0;
+
+	PPC405_SYS_INFO sys_info;
+
+	get_sys_info (&sys_info);
+	val = sys_info.freqPLB / sys_info.pllExtBusDiv;
+
+	return val;
+}
 
 /********************************************
  * get_PCI_freq
@@ -363,6 +378,21 @@
 	return val;
 }
 
+/********************************************
+ * get_EPB_freq
+ * return EPB bus freq in Hz
+ *********************************************/
+ulong get_EPB_freq (void)
+{
+	ulong val = 0;
+
+	PPC405_SYS_INFO sys_info;
+
+	get_sys_info (&sys_info);
+	val = sys_info.freqPLB / sys_info.pllExtBusDiv;
+
+	return val;
+}
 
 /********************************************
  * get_PCI_freq
Index: include/405gp_enet.h
===================================================================
RCS file: /srv/CVS/pplinux/u-boot/include/405gp_enet.h,v
retrieving revision 1.1.333.1
retrieving revision 1.3
diff -u -r1.1.333.1 -r1.3
--- include/405gp_enet.h	3 Feb 2005 09:43:16 -0000	1.1.333.1
+++ include/405gp_enet.h	6 Apr 2005 12:44:07 -0000	1.3
@@ -78,35 +78,42 @@
 #if defined(CONFIG_440)
 #define EMAC_BASE 			(CFG_PERIPHERAL_BASE + 0x0800)
 #else
-#define EMAC_BASE 			0xEF600800
+# define EMAC0_BASE 		        0xEF600800
+# define EMAC1_BASE                     0xEF600900
 #endif
 
-#define EMAC_M0 			(EMAC_BASE)
-#define EMAC_M1 			(EMAC_BASE + 4)
-#define EMAC_TXM0				(EMAC_BASE + 8)
-#define EMAC_TXM1		 		(EMAC_BASE + 12)
-#define EMAC_RXM		 		(EMAC_BASE + 16)
-#define EMAC_ISR		 		(EMAC_BASE + 20)
-#define EMAC_IER		 		(EMAC_BASE + 24)
-#define EMAC_IAH		 		(EMAC_BASE + 28)
-#define EMAC_IAL		 		(EMAC_BASE + 32)
-#define EMAC_VLAN_TPID_REG 		(EMAC_BASE + 36)
-#define EMAC_VLAN_TCI_REG 		(EMAC_BASE + 40)
-#define EMAC_PAUSE_TIME_REG 		(EMAC_BASE + 44)
-#define EMAC_IND_HASH_1			(EMAC_BASE + 48)
-#define EMAC_IND_HASH_2			(EMAC_BASE + 52)
-#define EMAC_IND_HASH_3			(EMAC_BASE + 56)
-#define EMAC_IND_HASH_4			(EMAC_BASE + 60)
-#define EMAC_GRP_HASH_1			(EMAC_BASE + 64)
-#define EMAC_GRP_HASH_2			(EMAC_BASE + 68)
-#define EMAC_GRP_HASH_3			(EMAC_BASE + 72)
-#define EMAC_GRP_HASH_4			(EMAC_BASE + 76)
-#define EMAC_LST_SRC_LOW		(EMAC_BASE + 80)
-#define EMAC_LST_SRC_HI			(EMAC_BASE + 84)
-#define EMAC_I_FRAME_GAP_REG		(EMAC_BASE + 88)
-#define EMAC_STACR			(EMAC_BASE + 92)
-#define EMAC_TRTR				(EMAC_BASE + 96)
-#define EMAC_RX_HI_LO_WMARK		(EMAC_BASE + 100)
+#define EMAC0_M0 			(EMAC0_BASE)
+#define EMAC1_M0 			(EMAC1_BASE)
+#define EMAC_M0 			(emac_base)
+#define EMAC_M1 			(emac_base + 4)
+#define EMAC_TXM0			(emac_base + 8)
+#define EMAC_TXM1			(emac_base + 12)
+#define EMAC_RXM			(emac_base + 16)
+#define EMAC_ISR			(emac_base + 20)
+#define EMAC_IER			(emac_base + 24)
+#define EMAC_IAH			(emac_base + 28)
+#define EMAC_IAL			(emac_base + 32)
+#define EMAC0_IAH			(EMAC0_BASE + 28)
+#define EMAC0_IAL			(EMAC0_BASE + 32)
+#define EMAC1_IAH			(EMAC1_BASE + 28)
+#define EMAC1_IAL			(EMAC1_BASE + 32)
+#define EMAC_VLAN_TPID_REG 		(emac_base + 36)
+#define EMAC_VLAN_TCI_REG 		(emac_base + 40)
+#define EMAC_PAUSE_TIME_REG 		(emac_base + 44)
+#define EMAC_IND_HASH_1			(emac_base + 48)
+#define EMAC_IND_HASH_2			(emac_base + 52)
+#define EMAC_IND_HASH_3			(emac_base + 56)
+#define EMAC_IND_HASH_4			(emac_base + 60)
+#define EMAC_GRP_HASH_1			(emac_base + 64)
+#define EMAC_GRP_HASH_2			(emac_base + 68)
+#define EMAC_GRP_HASH_3			(emac_base + 72)
+#define EMAC_GRP_HASH_4			(emac_base + 76)
+#define EMAC_LST_SRC_LOW		(emac_base + 80)
+#define EMAC_LST_SRC_HI			(emac_base + 84)
+#define EMAC_I_FRAME_GAP_REG		(emac_base + 88)
+#define EMAC_STACR			(0xEF600800 + 92)
+#define EMAC_TRTR			(emac_base + 96)
+#define EMAC_RX_HI_LO_WMARK		(emac_base + 100)
 
 /* bit definitions */
 /* MODE REG 0 */
Index: include/command.h
===================================================================
RCS file: /srv/CVS/pplinux/u-boot/include/command.h,v
retrieving revision 1.1.333.1
retrieving revision 1.2
diff -u -r1.1.333.1 -r1.2
--- include/command.h	3 Feb 2005 09:43:16 -0000	1.1.333.1
+++ include/command.h	3 Feb 2005 10:35:41 -0000	1.2
@@ -46,6 +46,9 @@
 #ifdef	CFG_LONGHELP
 	char		*help;		/* Help  message	(long)	*/
 #endif
+#ifdef CONFIG_PEPPERCON
+	int		user_allowed;	/* allow execution also in user mode */
+#endif
 };
 
 typedef struct cmd_tbl_s	cmd_tbl_t;
@@ -57,6 +60,10 @@
 /* common/command.c */
 cmd_tbl_t *find_cmd(const char *cmd);
 
+#if defined(CONFIG_PEPPERCON)
+void command_enable_user(const char *cmd);
+#endif
+
 /*
  * Monitor Command
  *
@@ -85,13 +92,23 @@
 
 #ifdef  CFG_LONGHELP
 
-#define U_BOOT_CMD(name,maxargs,rep,cmd,usage,help) \
-cmd_tbl_t __u_boot_cmd_##name Struct_Section = {#name, maxargs, rep, cmd, usage, help}
+# ifdef CONFIG_PEPPERCON
+#  define U_BOOT_CMD(name,maxargs,rep,cmd,usage,help) \
+	cmd_tbl_t __u_boot_cmd_##name Struct_Section = {#name, maxargs, rep, cmd, usage, help, 0}
+# else /* !CONFIG_PEPPERCON */
+#  define U_BOOT_CMD(name,maxargs,rep,cmd,usage,help) \
+	cmd_tbl_t __u_boot_cmd_##name Struct_Section = {#name, maxargs, rep, cmd, usage, help}
+# endif /* !CONFIG_PEPPERCON */
 
 #else	/* no long help info */
 
-#define U_BOOT_CMD(name,maxargs,rep,cmd,usage,help) \
-cmd_tbl_t __u_boot_cmd_##name Struct_Section = {#name, maxargs, rep, cmd, usage}
+# ifdef CONFIG_PEPPERCON
+#  define U_BOOT_CMD(name,maxargs,rep,cmd,usage,help) \
+	cmd_tbl_t __u_boot_cmd_##name Struct_Section = {#name, maxargs, rep, cmd, usage, 0}
+# else /* !CONFIG_PEPPERCON */
+#  define U_BOOT_CMD(name,maxargs,rep,cmd,usage,help) \
+	cmd_tbl_t __u_boot_cmd_##name Struct_Section = {#name, maxargs, rep, cmd, usage}
+#endif /* !CONFIG_PEPPERCON */
 
 #endif	/* CFG_LONGHELP */
 
Index: include/common.h
===================================================================
RCS file: /srv/CVS/pplinux/u-boot/include/common.h,v
retrieving revision 1.1.333.1
retrieving revision 1.3
diff -u -r1.1.333.1 -r1.3
--- include/common.h	3 Feb 2005 09:43:16 -0000	1.1.333.1
+++ include/common.h	29 Apr 2005 08:43:30 -0000	1.3
@@ -147,7 +147,11 @@
 
 /* common/main.c */
 void	main_loop	(void);
+#ifdef CONFIG_PEPPERCON
+int	run_command	(const char *cmd, int flag, int);
+#else
 int	run_command	(const char *cmd, int flag);
+#endif
 int	readline	(const char *const prompt);
 void	init_cmd_timeout(void);
 void	reset_cmd_timeout(void);
@@ -155,13 +159,18 @@
 /* lib_$(ARCH)/board.c */
 void	board_init_f  (ulong);
 void	board_init_r  (gd_t *, ulong);
-int	checkboard    (void);
 int	checkflash    (void);
 int	checkdram     (void);
 char *	strmhz(char *buf, long hz);
 int	last_stage_init(void);
 extern ulong monitor_flash_len;
 
+#ifdef CONFIG_PEPPERCON
+unsigned char checkboard (void);
+#else
+int checkboard (void);
+#endif
+
 /* common/flash.c */
 void flash_perror (int);
 
@@ -278,6 +287,13 @@
 
 /* $(BOARD)/$(BOARD).c */
 int board_pre_init (void);
+#ifdef CONFIG_PEPPERCON
+int  board_serial_init (void);
+int  board_reinit_pll(void);
+# ifdef PP_FEAT_USBPOWERED
+void toggle_led_state(void);
+# endif
+#endif
 int board_post_init (void);
 int board_postclk_init (void); /* after clocks/timebase, before env/serial */
 void board_poweroff (void);
@@ -343,6 +359,9 @@
 void	serial_addr   (unsigned int);
 int	serial_getc   (void);
 int	serial_tstc   (void);
+#ifdef CONFIG_PEPPERCON
+int	serial_debug_cable_present (void);
+#endif
 
 /* $(CPU)/speed.c */
 int	get_clocks (void);
@@ -354,6 +373,7 @@
 #endif
 #ifdef CONFIG_4xx
 ulong	get_OPB_freq (void);
+ulong	get_EPB_freq (void);
 ulong	get_PCI_freq (void);
 #endif
 #if defined(CONFIG_S3C2400) || defined(CONFIG_S3C2410)
@@ -503,4 +523,13 @@
 void	show_boot_progress (int status);
 #endif
 
+#ifdef CONFIG_PEPPERCON
+
+/* defines for the default jumper/command setting */
+# define PP_DEFAULTS_NONE       0
+# define PP_DEFAULTS_JUMPER     1
+# define PP_DEFAULTS_COMMAND    2       
+
+#endif
+
 #endif	/* __COMMON_H_ */
Index: include/ppc405.h
===================================================================
RCS file: /srv/CVS/pplinux/u-boot/include/ppc405.h,v
retrieving revision 1.1.333.1
retrieving revision 1.3
diff -u -r1.1.333.1 -r1.3
--- include/ppc405.h	3 Feb 2005 09:43:16 -0000	1.1.333.1
+++ include/ppc405.h	6 Apr 2005 12:44:07 -0000	1.3
@@ -572,10 +572,14 @@
 #define malrxcarr  (MAL_DCR_BASE+0x11)  /* RX Channel active reg (Reset)     */
 #define malrxeobisr (MAL_DCR_BASE+0x12) /* RX End of buffer int status reg   */
 #define malrxdeir  (MAL_DCR_BASE+0x13)  /* RX Descr. Error Int reg           */
-#define maltxctp0r (MAL_DCR_BASE+0x20)  /* TX 0 Channel table pointer reg    */
-#define maltxctp1r (MAL_DCR_BASE+0x21)  /* TX 1 Channel table pointer reg    */
-#define malrxctp0r (MAL_DCR_BASE+0x40)  /* RX 0 Channel table pointer reg    */
-#define malrcbs0   (MAL_DCR_BASE+0x60)  /* RX 0 Channel buffer size reg      */
+#define maltxctp0r_0 (MAL_DCR_BASE+0x20) /* TX 0 Channel table pointer reg    */
+#define maltxctp1r_0 (MAL_DCR_BASE+0x21) /* TX 1 Channel table pointer reg    */
+#define malrxctp0r_0 (MAL_DCR_BASE+0x40) /* RX 0 Channel table pointer reg    */
+#define malrcbs0_0   (MAL_DCR_BASE+0x60) /* RX 0 Channel buffer size reg      */
+#define maltxctp0r_1 (MAL_DCR_BASE+0x22) /* TX 0 Channel table pointer reg    */
+#define maltxctp1r_1 (MAL_DCR_BASE+0x23) /* TX 1 Channel table pointer reg    */
+#define malrxctp0r_1 (MAL_DCR_BASE+0x41) /* RX 0 Channel table pointer reg    */
+#define malrcbs0_1   (MAL_DCR_BASE+0x61) /* RX 0 Channel buffer size reg      */
 
 /*-----------------------------------------------------------------------------
 | IIC Register Offsets
Index: include/asm-ppc/global_data.h
===================================================================
RCS file: /srv/CVS/pplinux/u-boot/include/asm-ppc/global_data.h,v
retrieving revision 1.1.333.1
retrieving revision 1.2
diff -u -r1.1.333.1 -r1.2
--- include/asm-ppc/global_data.h	3 Feb 2005 09:43:16 -0000	1.1.333.1
+++ include/asm-ppc/global_data.h	3 Feb 2005 10:35:41 -0000	1.2
@@ -88,6 +88,13 @@
 #ifdef CONFIG_LWMON
 	unsigned long kbd_status;
 #endif
+#if defined(CONFIG_PEPPERCON)
+	unsigned int	debug_cable_present;
+	unsigned int	serial_debug;
+	unsigned int	devel_mode;
+	unsigned int	cable_kme;
+	unsigned char   hwid;
+#endif
 	void		**jt;		/* jump table */
 } gd_t;
 
Index: include/asm-ppc/u-boot.h
===================================================================
RCS file: /srv/CVS/pplinux/u-boot/include/asm-ppc/u-boot.h,v
retrieving revision 1.1.333.1
retrieving revision 1.3
diff -u -r1.1.333.1 -r1.3
--- include/asm-ppc/u-boot.h	3 Feb 2005 09:43:16 -0000	1.1.333.1
+++ include/asm-ppc/u-boot.h	29 Apr 2005 08:43:30 -0000	1.3
@@ -47,7 +47,8 @@
 #endif
 	unsigned long	bi_bootflags;	/* boot / reboot flag (for LynxOS) */
 	unsigned long	bi_ip_addr;	/* IP Address */
-	unsigned char	bi_enetaddr[6];	/* Ethernet adress */
+	unsigned char	bi_enetaddr[6]; /* Ethernet adress for 1st interface */
+	unsigned char	bi_enetaddr2[6]; /* Ethernet adress for 2nd interface */
 	unsigned short	bi_ethspeed;	/* Ethernet speed in Mbps */
 	unsigned long	bi_intfreq;	/* Internal Freq, in MHz */
 	unsigned long	bi_busfreq;	/* Bus Freq, in MHz */
@@ -95,6 +96,16 @@
 #if defined(CONFIG_NX823)
 	unsigned char	bi_sernum[8];
 #endif
+#ifdef CONFIG_PEPPERCON
+	unsigned int    bi_debug_mode;	/* 1 if debug cable was found on uart0*/
+	unsigned int	bi_def_jumper_set; /* defaults jumper/command state */
+	unsigned int	bi_cable_kme;   /* 1 if cable kme was found on uart0 */
+	unsigned int	bi_config_mode;	/* 1 if config cmd used for bootup */
+	unsigned int	bi_opb_busfreq;	/* OPB Bus speed, in Hz */
+	int		bi_iic_fast[1];	/* Use fast i2c mode */    
+	unsigned char   bi_hwid;	/* hardware id of the board */
+        unsigned int	bi_epb_busfreq;	/* EPB Bus speed, in Hz */
+#endif /* CONFIG_PEPPERCON */
 } bd_t;
 
 #endif /* __ASSEMBLY__ */
Index: include/configs/PEPPERCON.h
===================================================================
RCS file: include/configs/PEPPERCON.h
diff -N include/configs/PEPPERCON.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ include/configs/PEPPERCON.h	24 May 2005 14:01:50 -0000	1.5
@@ -0,0 +1,397 @@
+/*
+ * (C) Copyright 2000, 2001
+ * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
+ *
+ * Derived work: (C) Copyright 2002-2005 Peppercon AG
+ *
+ * See file CREDITS for list of people who contributed to this
+ * project.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of
+ * the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ * MA 02111-1307 USA
+ */
+
+/*
+ * board/config.h - configuration options, board specific
+ */
+
+#ifndef __CONFIG_H
+#define __CONFIG_H
+
+/*
+ * Include our board specific stuff.
+ */
+#include <peppercon.h>
+
+/*
+ * High Level Configuration Options
+ * (easy to change)
+ */
+
+#if PP_(CPU_TYPE, PP_HWID) == PP_CPU_405GP
+# define CONFIG_405GP		1
+#elif PP_(CPU_TYPE, PP_HWID) == PP_CPU_405EP
+# define CONFIG_405EP		1
+#else
+# error Unexpected processor type!
+#endif
+#define CONFIG_4xx		1	/* ...member of PPC4xx family */
+#define CONFIG_PEPPERCON	1	/* ...on a PEPPERCON board */
+#define CONFIG_BOARD_PRE_INIT	1	/* Call board_pre_init */
+#define CONFIG_BZIP2		1	/* We use bzip2 compressed images */
+#define DYNAMIC_CRC_TABLE	1	/* save some bytes */
+#define CONFIG_SYS_CLK_FREQ	PP_(SYS_CLK_FREQ, PP_HWID) /* external frequency to PLL */
+#define CFG_ENV_IS_IN_FLASH     1	/* use FLASH for environment vars */
+#define CONFIG_BOOTDELAY	3	/* autoboot delay */
+#define CONFIG_BAUDRATE		115200
+#if PP_(CONSOLE, PP_HWID) == PP_SERIAL_1
+# define CONFIG_UART1_CONSOLE 1
+#endif
+
+
+/*
+ * If CFG_EXT_SERIAL_CLOCK, then the UART divisor is 1.
+ * If CFG_405_UART_ERRATA_59, then UART divisor is 31.
+ * Otherwise, UART divisor is determined by CPU Clock and CFG_BASE_BAUD value.
+ * The Linux BASE_BAUD define should match this configuration.
+ *    baseBaud = cpuClock/(uartDivisor*16)
+ * If CFG_405_UART_ERRATA_59 and 200MHz CPU clock,
+ * set Linux BASE_BAUD to 403200.
+ */
+#undef  CFG_EXT_SERIAL_CLOCK	/* external serial clock */
+#undef  CFG_405_UART_ERRATA_59	/* 405GP/CR Rev. D silicon */
+#define CFG_BASE_BAUD		691200
+/* The following table includes the supported baudrates */
+#define CFG_BAUDRATE_TABLE  \
+	{300, 600, 1200, 2400, 4800, 9600, 19200, 38400, 57600, 115200, 230400}
+
+/*
+ * Size (bytes) of interrupt driven serial port buffer.
+ * Set to 0 to use polling instead of interrupts.
+ * Setting to 0 will also disable RTS/CTS handshaking.
+ */
+#if 0
+# define CONFIG_SERIAL_SOFTWARE_FIFO 4000
+#else
+# undef  CONFIG_SERIAL_SOFTWARE_FIFO
+#endif
+
+
+/*
+ * if PP_PRODUCTION, we use environment options (also depending on hardware)
+ * to autoboot directly from the production NFS server to start
+ * flashing the firmware or to switch the OEM version
+ * if !PP_PRODUCTION, the default (ramdisk...) env options are used
+ */
+
+#ifdef PP_PRODUCTION
+
+/* PP_PRODUCTION */
+
+#  undef CFG_SERIAL_DEBUG       /* don't test for serial debug cable */
+#  define CONFIG_BOOTCOMMAND	"tftpboot"
+#  define CONFIG_ETHADDR	FE:00:00:FF:00:00
+#  define CONFIG_SERVERIP	192.168.5.1
+#  define CFG_AUTOLOAD  	"yes"
+#  define CONFIG_EXTRA_ENV_SETTINGS       \
+    "autostart=yes\0"			  \
+    "serial_debug=1\0"
+
+#  define CONFIG_IPADDR	192.168.5.22
+#  define CONFIG_BOOTFILE zImage.lara.kim.prod
+#  define ROOTFS_PRODUCTION /install_root_devel
+
+#  define CONFIG_BOOTARGS						\
+    _CONFIG_BOOTARGS_PRODUCTION(CONFIG_IPADDR, ROOTFS_PRODUCTION)
+
+#  define _CONFIG_BOOTARGS_PRODUCTION(ip, rootfs)	\
+    __CONFIG_BOOTARGS_PRODUCTION(ip, rootfs)
+
+#  define __CONFIG_BOOTARGS_PRODUCTION(ip, rootfs)	\
+    "console=ttyS0,115200 root=/dev/nfs "		\
+    "nfsroot=192.168.5.1:" #rootfs			\
+    " ip=" #ip ":192.168.5.1 "				\
+    "wdt=90 rw " PP_BIGPHYSAREA_OPT(PP_HWID)
+
+#else
+
+/* NOT PP_PRODUCTION */
+
+#  define CFG_SERIAL_DEBUG	1	/* test for serial debug cable */
+#  if PP_(FLASH_SIZE,PP_HWID) == (4*1024*1024)
+#    define CONFIG_BOOTCOMMAND	"bootm ffc00000 ffcc0000"
+#  elif PP_(FLASH_SIZE,PP_HWID) == (8*1024*1024)
+#    define CONFIG_BOOTCOMMAND	"bootm ff800000 ff8e0000"
+#  elif PP_(FLASH_SIZE,PP_HWID) == (16*1024*1024)
+#    define CONFIG_BOOTCOMMAND	"bootm ff000000 ff0e0000"
+#  else
+#    error Unexpected flash size!
+#  endif
+
+
+#  ifdef CONFIG_UART1_CONSOLE
+#    define CONFIG_BOOTARGS    "console=ttyS1,115200 root=/dev/ram " \
+                               "ramdisk_size=8192 init=/sbin/init "  \
+                               "ip=off wdt=90 rw " PP_BIGPHYSAREA_OPT(PP_HWID)
+#  else
+#    define CONFIG_BOOTARGS    "console=ttyS0,115200 root=/dev/ram " \
+                               "ramdisk_size=8192 init=/sbin/init "  \
+                               "ip=off wdt=90 rw " PP_BIGPHYSAREA_OPT(PP_HWID)
+#  endif
+#endif
+
+
+#define CONFIG_LOADS_ECHO	1	/* echo on for serial download */
+#define CFG_LOADS_BAUD_CHANGE	1	/* allow baudrate change */
+#define CONFIG_MII		1	/* MII PHY management */
+#define	CONFIG_PREF_PHY_ADDR	1	/* Prefered PHY address (for >1 PHY) */
+
+#define CONFIG_COMMANDS		(CFG_CMD_BDI		\
+				 | CFG_CMD_BOOTD	\
+				 | CFG_CMD_IMI		\
+				 | CFG_CMD_FLASH	\
+				 | CFG_CMD_MEMORY	\
+				 | CFG_CMD_NET		\
+				 | CFG_CMD_ENV		\
+				 | CFG_CMD_PCI		\
+				 | CFG_CMD_RUN		\
+				 | CFG_CMD_LOADB	\
+				 )
+
+/* this must be included AFTER the definition of CONFIG_COMMANDS (if any) */
+#include <cmd_confdefs.h>
+
+#undef CONFIG_WATCHDOG			/* watchdog disabled */
+
+/*
+ * Miscellaneous configurable options
+ */
+#undef CFG_LONGHELP			/* undef to save memory */
+#define CFG_PROMPT	"=> "		/* Monitor Command Prompt */
+#if (CONFIG_COMMANDS & CFG_CMD_KGDB)
+# define CFG_CBSIZE	1024		/* Console I/O Buffer Size */
+#else
+# define CFG_CBSIZE	256		/* Console I/O Buffer Size */
+#endif
+#define CFG_PBSIZE (CFG_CBSIZE+sizeof(CFG_PROMPT)+16) /* Print Buffer Size */
+#define CFG_MAXARGS	16		/* max number of command args */
+#define CFG_BARGSIZE	CFG_CBSIZE	/* Boot Argument Buffer Size */
+
+#define CFG_MEMTEST_START	0x0400000	/* memtest works on */
+#define CFG_MEMTEST_END		0x0C00000	/* 4 ... 12 MB in DRAM */
+#define CFG_LOAD_ADDR		0x200000	/* default load address */
+#define CFG_EXTBDINFO		1	/* To use extended board_into (bd_t) */
+#define	CFG_HZ			1000	/* decrementer freq: 1 ms ticks	*/
+#define CONFIG_HARD_I2C		1	/* I2C with hardware support	*/
+#undef  CONFIG_SOFT_I2C			/* I2C bit-banged		*/
+#define CFG_I2C_SPEED		400000	/* I2C speed and slave address	*/
+#define CFG_I2C_SLAVE		0
+
+/*-----------------------------------------------------------------------
+ * PCI stuff
+ *-----------------------------------------------------------------------
+ */
+#define PCI_HOST_ADAPTER	0	/* configure as pci adapter     */
+#define PCI_HOST_FORCE		1	/* configure as pci host        */
+#define PCI_HOST_AUTO		2       /* detected via arbiter enable  */
+
+#define CONFIG_PCI			/* include pci support	        */
+#define CONFIG_PCI_HOST	PCI_HOST_FORCE  /* select pci host function     */
+#undef CONFIG_PCI_PNP			/* no pci plug-and-play         */
+					/* resource configuration       */
+
+#define CFG_PCI_VENDORID 0x1743		/* PCI Vendor ID: Peppercon AG  */
+#define CFG_PCI_DEVICEID 0x0405		/* PCI Device ID: 405           */
+#define CFG_PCI_SUBSYS_VENDORID 0x1743	/* PCI Vendor ID: Peppercon AG  */
+#define CFG_PCI_SUBSYS_DEVICEID 0x0405	/* PCI Device ID: 405           */
+
+#define CFG_PCI_CLASSCODE 0x0600	/* PCI Class Code: Bridge	*/
+
+/* --- PCI resources ---- */
+
+/* PLB -> PCI Region 0 */
+#define CFG_PCI_PMM0LA    0x80000000    /* map PCI MEM			*/
+#define CFG_PCI_PMM0PCILA 0x80000000
+#define CFG_PCI_PMM0PCIHA 0x00000000
+#define CFG_PCI_PMM0MA    0xC0000001    /* 1GB; no prefetching; enable	*/
+
+/* PLB -> PCI Region 1 */
+#define CFG_PCI_PMM1LA    0x00000000	/* disabled			*/
+#define CFG_PCI_PMM1PCILA 0x00000000
+#define CFG_PCI_PMM1PCIHA 0x00000000
+#define CFG_PCI_PMM1MA    0x00000000
+
+/* PLB -> PCI Region 2 */
+#define CFG_PCI_PMM2LA     0x00000000	/* disabled			*/
+#define CFG_PCI_PMM2PCILA  0x00000000
+#define CFG_PCI_PMM2PCIHA  0x00000000
+#define CFG_PCI_PMM2MA     0x00000000
+
+/* PCI -> PLB Region 1 */
+#define CFG_PCI_PTM1LA     0x00000000	/* point to PPC memory          */
+#define CFG_PCI_PTM1MS	   0xFC000001	/* 64 MB			*/
+#define CFG_PCI_PTM1PCI    0x00000000   /* Host: use this pci address   */
+	
+/* PCI -> PLB Region 2 */
+#define CFG_PCI_PTM2LA     0x00000000   /* disabled			*/
+#define CFG_PCI_PTM2MS     0x00000000
+#define CFG_PCI_PTM2PCI    0x00000000
+
+/* --------------------------------------------------------------------------
+ * GPIO stuff (only for PPC405EP)
+ */
+#ifdef CONFIG_405EP
+# define CFG_GPIO0_OSRH  PP_CALC_GPIO0_OSRH(PP_HWID)
+# define CFG_GPIO0_OSRL  PP_CALC_GPIO0_OSRL(PP_HWID)
+# define CFG_GPIO0_ISR1H 0x55555555
+# define CFG_GPIO0_ISR1L 0x55555555
+# define CFG_GPIO0_TSRH  0x00000000
+# define CFG_GPIO0_TSRL  0x00000000
+# define CFG_GPIO0_TCR   PP_CALC_GPIO0_TCR(PP_HWID)
+#endif
+
+/* --------------------------------------------------------------------------
+ * External Bus Controller
+ */
+
+/* The Peripheral Bank Access Parameters */
+#define CFG_EBC_PB0AP	PP_CALC_EBC0_BnAP(PP_HWID, 00)
+#define CFG_EBC_PB1AP	PP_CALC_EBC0_BnAP(PP_HWID, 01)
+#define CFG_EBC_PB2AP	PP_CALC_EBC0_BnAP(PP_HWID, 02)
+#define CFG_EBC_PB3AP	PP_CALC_EBC0_BnAP(PP_HWID, 03)
+#define CFG_EBC_PB4AP	PP_CALC_EBC0_BnAP(PP_HWID, 04)
+#ifndef CONFIG_405EP /* PPC405EP has only 5 chip selects */
+# define CFG_EBC_PB5AP	PP_CALC_EBC0_BnAP(PP_HWID, 05)
+# define CFG_EBC_PB6AP	PP_CALC_EBC0_BnAP(PP_HWID, 06)
+# define CFG_EBC_PB7AP	PP_CALC_EBC0_BnAP(PP_HWID, 07)
+#endif
+
+/* The Peripheral Bank Configuration Registers */
+#define CFG_EBC_PB0CR	PP_CALC_EBC0_BnCR(PP_HWID, 00)
+#define CFG_EBC_PB1CR	PP_CALC_EBC0_BnCR(PP_HWID, 01)
+#define CFG_EBC_PB2CR	PP_CALC_EBC0_BnCR(PP_HWID, 02)
+#define CFG_EBC_PB3CR	PP_CALC_EBC0_BnCR(PP_HWID, 03)
+#define CFG_EBC_PB4CR	PP_CALC_EBC0_BnCR(PP_HWID, 04)
+#ifndef CONFIG_405EP /* PPC405EP has only 5 chip selects */
+# define CFG_EBC_PB5CR	PP_CALC_EBC0_BnCR(PP_HWID, 05)
+# define CFG_EBC_PB6CR	PP_CALC_EBC0_BnCR(PP_HWID, 06)
+# define CFG_EBC_PB7CR	PP_CALC_EBC0_BnCR(PP_HWID, 07)
+#endif
+
+/* The EBC Configuration Register */
+#define CFG_EBC_EPCR	PP_CALC_EBC0_CFG(PP_HWID)
+
+/*-----------------------------------------------------------------------
+ * Start addresses for the final memory configuration
+ * (Set up by the startup code)
+ * Please note that CFG_SDRAM_BASE _must_ start at 0
+ */
+#define CFG_SDRAM_BASE		0x00000000
+#define CFG_FLASH_BASE		(0x0 - PP_(FLASH_SIZE, PP_HWID))
+#define CFG_MONITOR_BASE	0xFFFE0000	/* last 128 kB */
+#define CFG_MONITOR_LEN		(128 * 1024)	/* Reserve 128 kB for Monitor */
+#define CFG_MALLOC_LEN		(8192 * 1024)	/* Reserve 8MB for malloc() */
+						/* ... because of bzip2 */
+
+/*
+ * For booting Linux, the board info and command line data
+ * have to be in the first 8 MB of memory, since this is
+ * the maximum mapped by the Linux kernel during initialization.
+ */
+#define CFG_BOOTMAPSZ		(8 << 20)	/* Initial Mem-map for Linux */
+
+/*-----------------------------------------------------------------------
+ * FLASH organization
+ */
+#define CFG_FLASH_CFI		1	/* Flash is CFI conformant */
+#define CFG_FLASH_USE_BUFFER_WRITE 1	/* use buffered writes (20x faster) */
+#define CFG_FLASH_INCREMENT	0	/* there is only one bank */
+#define CFG_MAX_FLASH_BANKS	1	/* max number of memory banks */
+#define CFG_SECT_SIZE		(128*1024) /* sector size in bytes */
+#define CFG_MAX_FLASH_SECT	(PP_(FLASH_SIZE, PP_HWID) / CFG_SECT_SIZE) /* max number of sectors on one chip */
+#define CFG_FLASH_ERASE_TOUT	120000	/* Timeout for Flash Erase (in ms) */
+#define CFG_FLASH_WRITE_TOUT	500	/* Timeout for Flash Write (in ms) */
+
+/*
+ * NOTE: The environment is placed via the linker script 'u-boot.lds' at the
+ *       end of the boot monitor right before the reset vector.
+ */
+#ifdef CFG_ENV_IS_IN_FLASH
+# define CFG_ENV_SECT_SIZE	(128*1024) /* environment sector total size */
+# define CFG_ENV_SIZE		512	/* environment size */
+# define CFG_ENV_ADDR		(CFG_MONITOR_BASE + CFG_MONITOR_LEN - CFG_ENV_SIZE - 0x10) /* let space for reset vector */
+# define CFG_ENV_OFFSET		(CFG_ENV_ADDR - CFG_FLASH_BASE)
+#endif
+
+/*-----------------------------------------------------------------------
+ * Cache Configuration
+ */
+#ifdef CONFIG_405EP
+# define CFG_DCACHE_SIZE	16384
+#else
+# define CFG_DCACHE_SIZE	 8192
+#endif
+#define CFG_CACHELINE_SIZE	32
+#if (CONFIG_COMMANDS & CFG_CMD_KGDB)
+# define CFG_CACHELINE_SHIFT	5	/* log base 2 of the above value */
+#endif
+
+/*-----------------------------------------------------------------------
+ * Init Memory Controller:
+ *
+ * BR0/1 and OR0/1 (FLASH)
+ */
+
+#define FLASH_BASE0_PRELIM	CFG_FLASH_BASE	/* FLASH bank #0	*/
+#define FLASH_BASE1_PRELIM	0		/* FLASH bank #1	*/
+
+/*-----------------------------------------------------------------------
+ * Definitions for initial stack pointer and data area
+ */
+#undef CFG_INIT_DCACHE_CS	/* no stack in data cache memory */
+#define CFG_INIT_RAM_ADDR	0x00df0000 /* Inside of SDRAM */
+#define CFG_INIT_RAM_END	0x2000	/* End of used area in RAM */
+#define CFG_GBL_DATA_SIZE	140	/* size in bytes reserved for initial data */
+#define CFG_GBL_DATA_OFFSET	(CFG_INIT_RAM_END - CFG_GBL_DATA_SIZE)
+#define CFG_INIT_SP_OFFSET	CFG_GBL_DATA_OFFSET
+
+/*-----------------------------------------------------------------------
+ * Internal Definitions
+ *
+ * Boot Flags
+ */
+#define BOOTFLAG_COLD	0x01		/* Normal Power-On: Boot from FLASH	*/
+#define BOOTFLAG_WARM	0x02		/* Software reboot			*/
+
+#if (CONFIG_COMMANDS & CFG_CMD_KGDB)
+# define CONFIG_KGDB_BAUDRATE	230400	/* speed to run kgdb serial port */
+# define CONFIG_KGDB_SER_INDEX	2	/* which serial port to use */
+#endif
+
+#ifdef CONFIG_405EP
+# define PLLMR0_DEFAULT PP_PLLMR0_DEFAULT(PP_HWID)
+# define PLLMR1_DEFAULT PP_PLLMR1_DEFAULT(PP_HWID)
+# define DYNAMIC_PLL	PP_DYNAMIC_PLL(PP_HWID)
+# if (PP_DYNAMIC_PLL(PP_HWID) == 1)
+#  define PLLMR0_SLOW	PP_PLLMR0_SLOW(PP_HWID)
+#  define PLLMR1_SLOW	PP_PLLMR1_SLOW(PP_HWID)
+#  define PLLMR0_FAST	PP_PLLMR0_FAST(PP_HWID)
+#  define PLLMR1_FAST	PP_PLLMR1_FAST(PP_HWID)
+#  define CPU_CLK_SLOW	PP_CPU_CLK_SLOW(PP_HWID)
+#  define CPU_CLK_FAST	PP_CPU_CLK_FAST(PP_HWID)
+# endif
+#endif
+
+#endif	/* __CONFIG_H */
Index: lib_generic/bzlib_decompress.c
===================================================================
RCS file: /srv/CVS/pplinux/u-boot/lib_generic/bzlib_decompress.c,v
retrieving revision 1.1.333.1
retrieving revision 1.2
diff -u -r1.1.333.1 -r1.2
--- lib_generic/bzlib_decompress.c	3 Feb 2005 09:43:19 -0000	1.1.333.1
+++ lib_generic/bzlib_decompress.c	3 Feb 2005 10:35:41 -0000	1.2
@@ -1,4 +1,5 @@
 #include <config.h>
+#include <common.h>
 #ifdef CONFIG_BZIP2
 
 /*-------------------------------------------------------------*/
@@ -151,7 +152,10 @@
    Int32      retVal;
    Int32      minLen, maxLen;
    bz_stream* strm = s->strm;
-
+#if defined(CONFIG_PEPPERCON) && defined(PP_FEAT_USBPOWERED)
+   unsigned int led_count = 0;
+#endif
+   
    /* stuff that needs to be saved/restored */
    Int32  i;
    Int32  j;
@@ -415,14 +419,19 @@
       GET_MTF_VAL(BZ_X_MTF_1, BZ_X_MTF_2, nextSym);
 
       while (True) {
-
+#if defined(CONFIG_PEPPERCON) && defined(PP_FEAT_USBPOWERED)
+	  if ((led_count++ % 10000) == 0) {
+	      toggle_led_state();
+	  }
+#endif
+	  
 	 if (nextSym == EOB) break;
 
 	 if (nextSym == BZ_RUNA || nextSym == BZ_RUNB) {
 
 	    es = -1;
 	    N = 1;
-	    do {
+	    do {		
 	       if (nextSym == BZ_RUNA) es = es + (0+1) * N; else
 	       if (nextSym == BZ_RUNB) es = es + (1+1) * N;
 	       N = N * 2;
@@ -531,7 +540,7 @@
       BZ_INITIALISE_CRC ( s->calculatedBlockCRC );
       s->state = BZ_X_OUTPUT;
       if (s->verbosity >= 2) VPrintf0 ( "rt+rld" );
-
+      
       /*-- Set up cftab to facilitate generation of T^(-1) --*/
       s->cftab[0] = 0;
       for (i = 1; i <= 256; i++) s->cftab[i] = s->unzftab[i-1];
@@ -588,7 +597,6 @@
 	 } else {
 	    BZ_GET_FAST(s->k0); s->nblock_used++;
 	 }
-
       }
 
       RETURN(BZ_OK);
Index: lib_generic/crc32.c
===================================================================
RCS file: /srv/CVS/pplinux/u-boot/lib_generic/crc32.c,v
retrieving revision 1.1.333.1
retrieving revision 1.2
diff -u -r1.1.333.1 -r1.2
--- lib_generic/crc32.c	3 Feb 2005 09:43:19 -0000	1.1.333.1
+++ lib_generic/crc32.c	3 Feb 2005 10:35:41 -0000	1.2
@@ -20,9 +20,7 @@
 
 #ifdef DYNAMIC_CRC_TABLE
 
-local int crc_table_empty = 1;
-local uLongf crc_table[256];
-local void make_crc_table OF((void));
+local void make_crc_table OF((uLongf * crc_table));
 
 /*
   Generate a table for a byte-wise 32-bit CRC calculation on the polynomial:
@@ -48,7 +46,7 @@
   the information needed to generate CRC's on data a byte at a time for all
   combinations of CRC register values and incoming bytes.
 */
-local void make_crc_table()
+local void make_crc_table(uLongf * crc_table)
 {
   uLong c;
   int n, k;
@@ -68,7 +66,6 @@
       c = c & 1 ? poly ^ (c >> 1) : c >> 1;
     crc_table[n] = c;
   }
-  crc_table_empty = 0;
 }
 #else
 /* ========================================================================
@@ -156,8 +153,8 @@
     uInt len;
 {
 #ifdef DYNAMIC_CRC_TABLE
-    if (crc_table_empty)
-      make_crc_table();
+    uLongf crc_table[256];
+    make_crc_table(crc_table);
 #endif
     crc = crc ^ 0xffffffffL;
     while (len >= 8)
@@ -179,8 +176,8 @@
 uLong ZEXPORT crc32_no_comp(uLong crc, const Bytef *buf, uInt len)
 {
 #ifdef DYNAMIC_CRC_TABLE
-    if (crc_table_empty)
-      make_crc_table();
+    uLongf crc_table[256];
+    make_crc_table(crc_table);
 #endif
     while (len >= 8)
     {
